// *********************(c)*2004*********************>
// -holzilib--holzilib--holzilib--holzilib--holzilib->
// ++++PD-External++by+Georg+Holzmann++grh@gmx.at++++>
//
// PDContainer: 
// this is a port of the containers from the C++ STL
// (Standard Template Library)
// for usage see the documentation and PD help files
// for license see readme.txt
//
// HMap.h

#ifndef h_map_h__
#define h_map_h__


#include "include/TMapBase.h"
#include <map>

using std::map;

//---------------------------------------------------
/* this is the class of the map
 */
class HMap : 
public TMapBase< map<Element,atom,Compare>, map<Element,atom,Compare>::iterator >
{

 private:

  /* Copy Construction is not allowed
   */
  HMap(const HMap &src)
    { }

  /* assignement operator is not allowed
   */
  const HMap& operator = (const HMap&)
    { return *this; }

 public:

  // Constructor
  // no namespace
  HMap()
    { }

  // Constructor
  // with a namespace
  HMap(string h_namespace)
    { h_namespace_ = h_namespace; }

  // Destructor
  virtual ~HMap() { }

  // these functions doesn't work::::
/*   virtual void clearAll() { } */
/*   virtual void clearNamespace() { } */
/*   virtual void printAll() { } */
/*   virtual bool saveToFile(string filename) { } */
/*   virtual bool readFromFile(string filename) { } */
/*   virtual void add(atom key, atom value) { } */
/*   virtual atom &get(atom &key) const { } */
};





#endif   // h_map_h__
